Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Public Attributes | List of all members
DistributedActor Class Reference
Inheritance diagram for DistributedActor:

## Public Member Functions
| __init__ (self, cr)
| delete (self)
| disable (self)
| loop (self, animName, restart=1, partName=None, fromFrame=None, toFrame=None)
Public Member Functions inherited from DistributedNode
| __init__ (self, cr)
| __cmp__ (self, other)
| b_setParent (self, parentToken)
| setParent ###
| d_setH (self, h)
| d_setHpr (self, h, p, r)
| d_setP (self, p)
| d_setParent (self, parentToken)
| d_setPos (self, x, y, z)
| d_setPosHpr (self, x, y, z, h, p, r)
| d_setR (self, r)
| d_setX (self, x)
| set pos and hpr functions #######
| d_setXY (self, x, y)
| d_setXYH (self, x, y, h)
| d_setXYZH (self, x, y, z, h)
| d_setXZ (self, x, z)
| d_setY (self, y)
| d_setZ (self, z)
| do_setParent (self, parentToken)
| generate (self)
| setLocation (self, parentId, zoneId, teleport=0)
| setParent (self, parentToken)
| setParentStr (self, parentTokenStr)
| setXY (self, x, y)
| setXYH (self, x, y, h)
| setXYZH (self, x, y, z, h)
| setXZ (self, x, z)
Public Member Functions inherited from DistributedObject
| __init__ (self, cr)
| addInterest (self, zoneId, note="", event=None)
| announceGenerate (self)
| b_setLocation (self, parentId, zoneId)
| d_setLocation (self, parentId, zoneId)
| deleteOrDelay (self)
| disableAndAnnounce (self)
| disableAnnounceAndDelete (self)
| doCallbackContext (self, context, args)
| doneBarrier (self, name=None)
| execCommand (self, string, mwMgrId, avId, zoneId)
| flushCachedData (self, name)
| generateInit (self)
| getAutoInterests (self)
| getBarrierData (self)
| getCacheable (self)
| getCachedData (self, name)
| getCallback (self, context)
| getCallbackArgs (self, context)
| getCallbackContext (self, callback, extraArgs=[])
| getCurrentContexts (self)
| getDelayDeleteCount (self)
| getDelayDeleteEvent (self)
| getDisableEvent (self)
| getDoId (self)
| getLocation (self)
| getNeverDisable (self)
| getParentObj (self)
| hasCachedData (self, name)
| isDisabled (self)
| isGenerated (self)
| isGridParent (self)
| isLocal (self)
| postGenerateMessage (self)
| removeInterest (self, handle, event=None)
| sendDeleteMsg (self)
| sendDisableMsg (self)
| sendUpdate (self, fieldName, args=[], sendToId=None)
| setBarrierData (self, data)
| setCacheable (self, bool)
| setCachedData (self, name, data)
| setNeverDisable (self, bool)
| status (self, indent=0)
| taskName (self, taskString)
| uniqueName (self, idString)
| updateAllRequiredFields (self, dclass, di)
| updateRequiredFields (self, dclass, di)
| updateRequiredOtherFields (self, dclass, di)
Public Member Functions inherited from DistributedObjectBase
| __init__ (self, cr)
| handleChildArrive (self, childObj, zoneId)
| handleChildArriveZone (self, childObj, zoneId)
| handleChildLeave (self, childObj, zoneId)
| handleChildLeaveZone (self, childObj, zoneId)
| handleQueryObjectChildrenLocalDone (self, context)
| hasParentingRules (self)
Public Member Functions inherited from DirectObject
| __init__ (self)
| accept (self, event, method, extraArgs=[])
| acceptOnce (self, event, method, extraArgs=[])
| addTask (self, *args, **kwargs)
| detectLeaks (self)
| doMethodLater (self, *args, **kwargs)
| getAllAccepting (self)
| ignore (self, event)
| ignoreAll (self)
| isAccepting (self, event)
| isIgnoring (self, event)
| removeAllTasks (self)
| removeTask (self, taskOrName)
Public Member Functions inherited from Actor
| __init__ (self, models=None, anims=None, other=None, copy=True, lodNode=None, flattenable=True, setFinal=False, mergeLODBundles=None, allowAsyncBind=None, okMissing=None)
| __cmp__ (self, other)
| __str__ (self)
| actorInterval (self, *args, **kw)
| addLOD (self, lodName, inDist=0, outDist=0, center=None)
| animPanel (self)
| attach (self, partName, anotherPartName, jointName, lodName="lodRoot")
| bindAllAnims (self, allowAsyncBind=False)
| bindAnim (self, animName, partName=None, lodName=None, allowAsyncBind=False)
| cleanup (self)
| clearLODAnimation (self)
| clearPythonData (self)
| controlJoint (self, node, partName, jointName, lodName="lodRoot")
| copyActor (self, other, overwrite=False)
| disableBlend (self, partName=None)
| drawInFront (self, frontPartName, backPartName, mode, root=None, lodName=None)
| enableBlend (self, blendType=PartBundle.BTNormalizedLinear, partName=None)
| exposeJoint (self, node, partName, jointName, lodName="lodRoot", localTransform=0)
| faceAwayFromViewer (self)
| faceTowardsViewer (self)
| fixBounds (self, partName=None)
| fixBounds_old (self, part=None)
| flush (self)
| freezeJoint (self, partName, jointName, transform=None, pos=Vec3(0, 0, 0), hpr=Vec3(0, 0, 0), scale=Vec3(1, 1, 1))
| getActorInfo (self)
| getAnimBlends (self, animName=None, partName=None, lodName=None)
| getAnimControl (self, animName, partName=None, lodName=None, allowAsyncBind=True)
| getAnimControlDict (self)
| getAnimControls (self, animName=None, partName=None, lodName=None, allowAsyncBind=True)
| getAnimFilename (self, animName, partName='modelRoot')
| getAnimNames (self)
| getBaseFrameRate (self, animName=None, partName=None)
| getCurrentAnim (self, partName=None)
| getCurrentFrame (self, animName=None, partName=None)
| getDuration (self, animName=None, partName=None, fromFrame=None, toFrame=None)
| getFrameRate (self, animName=None, partName=None)
| getFrameTime (self, anim, frame, partName=None)
| getGeomNode (self)
| getJoints (self, partName=None, jointName=' *', lodName=None)
| getJointTransform (self, partName, jointName, lodName='lodRoot')
| getJointTransformState (self, partName, jointName, lodName='lodRoot')
| getLOD (self, lodName)
| getLODIndex (self, lodName)
| getLODNames (self)
| getLODNode (self)
| getNumFrames (self, animName=None, partName=None)
| getOverlappingJoints (self, partNameA, partNameB, jointName=' *', lodName=None)
| getPart (self, partName, lodName="lodRoot")
| getPartBundle (self, partName, lodName="lodRoot")
| getPartBundleDict (self)
| getPartBundles (self, partName=None)
| getPartNames (self)
| getPlayRate (self, animName=None, partName=None)
| getSubpartsComplete (self)
| hasLOD (self)
| hideAllBounds (self)
| hidePart (self, partName, lodName="lodRoot")
| initAnimsOnAllLODs (self, partNames)
| instance (self, path, partName, jointName, lodName="lodRoot")
| listJoints (self, partName="modelRoot", lodName="lodRoot")
| loadAnims (self, anims, partName="modelRoot", lodName="lodRoot")
| loadAnimsOnAllLODs (self, anims, partName="modelRoot")
| loadModel (self, modelPath, partName="modelRoot", lodName="lodRoot", copy=True, okMissing=None, autoBindAnims=True)
| makeSubpart (self, partName, includeJoints, excludeJoints=[], parent="modelRoot", overlapping=False)
| osdAnimBlends (self, animName=None, partName=None, lodName=None)
| pingpong (self, animName, restart=1, partName=None, fromFrame=None, toFrame=None)
| play (self, animName, partName=None, fromFrame=None, toFrame=None)
| pose (self, animName, frame, partName=None, lodName=None)
| postFlatten (self)
| pprint (self)
| printAnimBlends (self, animName=None, partName=None, lodName=None)
| printLOD (self)
| releaseJoint (self, partName, jointName)
| removeAnimControlDict (self)
| removeNode (self)
| removePart (self, partName, lodName="lodRoot")
| renamePartBundles (self, partName, newBundleName)
| resetLOD (self)
| setBlend (self, animBlend=None, frameBlend=None, blendType=None, partName=None)
| setCenter (self, center)
| setControlEffect (self, animName, effect, partName=None, lodName=None)
| setGeomNode (self, node)
| setLOD (self, lodName, inDist=0, outDist=0)
| setLODAnimation (self, farDistance, nearDistance, delayFactor)
| setLODNode (self, node=None)
| setPlayRate (self, rate, animName, partName=None)
| setSubpartsComplete (self, flag)
| showAllBounds (self)
| showAllParts (self, partName, lodName="lodRoot")
| showPart (self, partName, lodName="lodRoot")
| stop (self, animName=None, partName=None)
| stopJoint (self, partName, jointName, lodName="lodRoot")
| unloadAnims (self, anims=None, partName=None, lodName=None)
| update (self, lod=0, partName=None, lodName=None, force=False)
| useLOD (self, lodName)
| verifySubpartsComplete (self, partName=None, lodName=None)
| waitPending (self, partName=None)

## Public Attributes
int | DistributedActor_deleted = 1
int | DistributedActor_initialized = 1
Public Attributes inherited from DistributedNode
int | DistributedNode_deleted = 1
int | DistributedNode_initialized = 1
int | gotStringParentToken = 0
| gridParent = None
| this
Public Attributes inherited from DistributedObject
| activeState = ESNew
| autoInterests = autoInterests
| cacheable = ESGenerated:
| dclass = None
| destroyDoStackTrace
int | DistributedObject_deleted = 1
int | DistributedObject_initialized = 1
Public Attributes inherited from DistributedObjectBase
| cr = cr
| doId
int | parentId = None
| zoneId = None
Public Attributes inherited from Actor
int | Actor_deleted = 1
int | Actor_initialized = 1
int | gotName = 0
| loader = PandaLoader.getGlobalPtr()
dict | switches = None

## Additional Inherited Members
Static Public Attributes inherited from DistributedObject
int | neverDisable = 0
Static Public Attributes inherited from DistributedObjectBase
| notify = directNotify.newCategory("DistributedObjectBase")
Static Public Attributes inherited from DirectObject
| accept_once = acceptOnce
| add_task = addTask
| detect_leaks = detectLeaks
| do_method_later = doMethodLater
| get_all_accepting = getAllAccepting
| ignore_all = ignoreAll
| is_accepting = isAccepting
| is_ignoring = isIgnoring
| remove_all_tasks = removeAllTasks
| remove_task = removeTask
Static Public Attributes inherited from Actor
| actor_interval = actorInterval
| add_lod = addLOD
| allowAsyncBind = ConfigVariableBool('allow-async-bind', True)
| anim_panel = animPanel
| animLoaderOptions
| bind_all_anims = bindAllAnims
| bind_anim = bindAnim
| clear_lod_animation = clearLODAnimation
| clear_python_data = clearPythonData
| control_joint = controlJoint
| copy_actor = copyActor
| disable_blend = disableBlend
| draw_in_front = drawInFront
| enable_blend = enableBlend
| expose_joint = exposeJoint
| face_away_from_viewer = faceAwayFromViewer
| face_towards_viewer = faceTowardsViewer
| fix_bounds = fixBounds
| fix_bounds_old = fixBounds_old
| freeze_joint = freezeJoint
| get_actor_info = getActorInfo
| get_anim_blends = getAnimBlends
| get_anim_control = getAnimControl
| get_anim_control_dict = getAnimControlDict
| get_anim_controls = getAnimControls
| get_anim_filename = getAnimFilename
| get_anim_names = getAnimNames
| get_base_frame_rate = getBaseFrameRate
| get_current_anim = getCurrentAnim
| get_current_frame = getCurrentFrame
| get_duration = getDuration
| get_frame_rate = getFrameRate
| get_frame_time = getFrameTime
| get_geom_node = getGeomNode
| get_joint_transform = getJointTransform
| get_joint_transform_state = getJointTransformState
| get_joints = getJoints
| get_lod = getLOD
| get_lod_index = getLODIndex
| get_lod_names = getLODNames
| get_lod_node = getLODNode
| get_num_frames = getNumFrames
| get_overlapping_joints = getOverlappingJoints
| get_part = getPart
| get_part_bundle = getPartBundle
| get_part_bundle_dict = getPartBundleDict
| get_part_bundles = getPartBundles
| get_part_names = getPartNames
| get_play_rate = getPlayRate
| get_subparts_complete = getSubpartsComplete
| has_lod = hasLOD
| hide_all_bounds = hideAllBounds
| hide_part = hidePart
| init_anims_on_all_lods = initAnimsOnAllLODs
| list_joints = listJoints
| load_anims = loadAnims
| load_anims_on_all_lods = loadAnimsOnAllLODs
| load_model = loadModel
| make_subpart = makeSubpart
| mergeLODBundles = ConfigVariableBool('merge-lod-bundles', True)
| modelLoaderOptions
| notify = DirectNotifyGlobal.directNotify.newCategory("Actor")
| osd_anim_blends = osdAnimBlends
str | partPrefix = "__Actor_"
| post_flatten = postFlatten
| print_anim_blends = printAnimBlends
| print_lod = printLOD
| release_joint = releaseJoint
| remove_anim_control_dict = removeAnimControlDict
| remove_node = removeNode
| remove_part = removePart
| rename_part_bundles = renamePartBundles
| reset_lod = resetLOD
| set_blend = setBlend
| set_center = setCenter
| set_control_effect = setControlEffect
| set_geom_node = setGeomNode
| set_lod = setLOD
| set_lod_animation = setLODAnimation
| set_lod_node = setLODNode
| set_play_rate = setPlayRate
| set_subparts_complete = setSubpartsComplete
| show_all_bounds = showAllBounds
| show_all_parts = showAllParts
| show_part = showPart
| stop_joint = stopJoint
| unload_anims = unloadAnims
| use_lod = useLOD
| validateSubparts = ConfigVariableBool('validate-subparts', True)
| verify_subparts_complete = verifySubpartsComplete
| wait_pending = waitPending
Protected Member Functions inherited from DistributedObject
| _deactivateDO (self)
| _destroyDO (self)
| _retrieveCachedData (self)
Protected Member Functions inherited from DirectObject
| _addTask (self, task)
| _clearTask (self, task)
Protected Attributes inherited from DistributedObject
| _cachedData = self.cr.doDataCache.popCachedData(self.doId)
int | _delayDeleted = 0
bool | _delayDeleteForceAllow = False
dict | _token2delayDeleteName = {}
Protected Attributes inherited from DirectObject
dict | _taskList = {}

## Constructor & Destructor Documentation

## ◆ __init__()

__init__ | ( |  | self,
|  |  | cr )

## Member Function Documentation

## ◆ delete()

delete | ( |  | self | ) |

    Inheritors should redefine this to take appropriate action on delete

Reimplemented from DistributedNode.

## ◆ disable()

disable | ( |  | self | ) |

    Inheritors should redefine this to take appropriate action on disable

Reimplemented from DistributedNode.

## ◆ loop()

loop | ( |  | self,
|  |  | animName,
|  |  | restart = 1,
|  |  | partName = None,
|  |  | fromFrame = None,
|  |  | toFrame = None )

    loop(self, string, int=1, string=None)
    Loop the given animation on the given part of the actor,
    restarting at zero frame if requested. If no part name
    is given then try to loop on all parts. NOTE: loops on
    all LOD's

Reimplemented from Actor.

## Member Data Documentation

## ◆ DistributedActor_deleted

int DistributedActor_deleted = 1

## ◆ DistributedActor_initialized

int DistributedActor_initialized = 1